Page MenuHomePhabricator

Change the type search API to allow users to search for functions returning a type in addition to instances of that type
Closed, ResolvedPublic

Description

As an user I would like to be able to search the application not only from its type, but also for functions that return types (eg list generics).

The idea of this ticket (that is a follow up of the engineer meeting we had last week), is to allow the user to change what they search for on the main ZObject page, allowing them to also search for functions and not just types.

Possible blockers:

  • when searching for function I may not be able to know if a function return another type or a value and therefore selecting it may break the UI! I will investigate as part of this ticket

Related Objects

StatusSubtypeAssignedTask
OpenNone
OpenNone
StalledNone
Resolvedcmassaro
OpenNone
OpenNone
OpenNone
OpenNone
OpenNone
DuplicateNone
OpenNone
Resolvedcmassaro
OpenNone
ResolvedJdforrester-WMF
OpenNone
OpenNone
OpenNone
OpenNone
OpenNone
ResolvedNone
ResolvedNone
Resolvedcmassaro
Resolvedcmassaro
ResolvedNone
Resolvedgengh
Resolvedgengh
DeclinedLindsaykwardell
ResolvedLindsaykwardell
Resolvedcmassaro
Resolvedcmassaro
ResolvedNone
ResolvedNone
Resolvedcmassaro
ResolvedNone
InvalidNone
Invalidgengh
ResolvedNone
ResolvedNone
ResolvedJdforrester-WMF
ResolvedNone
ResolvedNone
DeclinedNone
ResolvedSimoneThisDot
ResolvedSimoneThisDot
Resolvedcmassaro
ResolvedSimoneThisDot
ResolvedSimoneThisDot
Resolvedgengh
Resolvedgengh
ResolvedJdforrester-WMF
ResolvedSimoneThisDot
ResolvedJdforrester-WMF
ResolvedDVrandecic
ResolvedNone
ResolvedNone
Resolvedcmassaro
ResolvedDVrandecic
ResolvedLindsaykwardell
Resolvedarthurlorenzi
ResolvedNone
InvalidNone
Resolvedcmassaro
Resolvedcmassaro
Resolvedcmassaro
Resolvedcmassaro
Resolvedcmassaro
ResolvedJdforrester-WMF
Resolvedcmassaro
Resolvedcmassaro
Resolvedcmassaro
ResolvedNone
ResolvedSimoneThisDot
ResolvedSimoneThisDot
ResolvedSimoneThisDot
ResolvedJdforrester-WMF
Resolvedcmassaro
Resolvedgengh
Resolvedcmassaro
ResolvedJdforrester-WMF
Resolvedcmassaro
Resolvedcmassaro
ResolvedNone
ResolvedDVrandecic
Resolvedcmassaro
Resolvedarthurlorenzi
ResolvedAdesojiThisDot

Event Timeline

We discussed two possible approaches for this, and I was originally suggesting to use the mode selector here just as in other places, as can be seen here:

mode-selector.png (113×289 px, 8 KB)

Instead Geno suggested that we extend the search to automatically not only search for Z4s but also for Z8s that would return a Z4. For that we will add a column on the labels table with the "resulting type" or "effective type" or whatever, and make that available for search. In that case we can show types and functions that return types together.

Once that is done on the backend, we still now need to be able to use these functions effectively. Thus this task is marked dependent on T262089

This should be an option against the backend (not in the UX!), i.e. I should be able to state whether 1) I want only Z4s, or 2) Z4s and Z8s which return a Z1 or a Z4.

DVrandecic renamed this task from Allow user to search for functions in CreateZObject page by adding a mode selector to Allow user to search for functions returning a type in addition to instances of that type.Dec 9 2021, 1:15 AM
SimoneThisDot changed the task status from Open to In Progress.Jan 6 2022, 7:54 AM
SimoneThisDot claimed this task.

The work has now been completed as part of T291043

I would like to see that demo'ed.

Hi Denny, you can just go on NotWIki and search for "typed pair" or "typed
map" they are Function that return type :)

Jdforrester-WMF renamed this task from Allow user to search for functions returning a type in addition to instances of that type to Change the type search API to allow users to search for functions returning a type in addition to instances of that type.Jan 25 2022, 5:18 PM
Jdforrester-WMF reopened this task as In Progress.
Jdforrester-WMF closed this task as Resolved.